%define anolis_release 1
%global pypi_name deepspeed
%global pypi_version 0.12.6
%global vcu_maj 12
%global vcu_min 1 

Name:           python-%{pypi_name}
Version:        %{pypi_version}
Release:        %{anolis_release}%{?dist}
Summary:        DeepSpeed library

License:        Apache Software License 2.0
URL:            http://deepspeed.ai
Source0:        %{pypi_source}

%define have_cuda 1
%define gpu_target_ptx "50"

%define gpu_target_bin 5.0;5.2;6.0;6.1;7.0;7.5;8.0;8.6;9.0

%if %{have_cuda}
BuildRequires:  cuda-nvcc-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-nvtx-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-cupti-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-nvprune-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-cudart-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-nvml-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-nvrtc-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-driver-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  cuda-profiler-api-%{vcu_maj}-%{vcu_min}
BuildRequires:  nvidia-driver-cuda-libs
BuildRequires:  libnpp-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcurand-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcusparse-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcublas-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcusolver-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcufft-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libcurand-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libnvjpeg-devel-%{vcu_maj}-%{vcu_min}
BuildRequires:  libnccl-devel
Requires:  cuda-cudart-%{vcu_maj}-%{vcu_min}
Requires:  cuda-nvrtc-%{vcu_maj}-%{vcu_min}
Requires:  cuda-nvtx-%{vcu_maj}-%{vcu_min}
%endif

BuildRequires:  python3-devel
BuildRequires:  python3dist(accelerate)
BuildRequires:  python3dist(coverage)
BuildRequires:  python3dist(future)
BuildRequires:  python3dist(importlib-metadata) >= 4
BuildRequires:  python3dist(pre-commit) >= 2.20
BuildRequires:  python3dist(recommonmark)
BuildRequires:  python3dist(setuptools)
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3dist(sphinx-rtd-theme)
BuildRequires:  python3dist(tensorboard)
BuildRequires:  python3dist(torchvision)
BuildRequires:  python3dist(transformers) >= 4.32.1
BuildRequires:  ninja-build

BuildArch:      noarch

%description
DeepSpeed is a deep learning optimization library that makes distributed 
training and inference easy, efficient, and effective. 

%package -n     python3-%{pypi_name}
Summary:        %{summary}
%{?python_provide:%python_provide python3-%{pypi_name}}


Requires:       python3dist(hjson)
Requires:       python3dist(numpy)
Requires:       python3dist(packaging) >= 20
Requires:       python3dist(psutil)
Requires:       python3dist(py-cpuinfo)
Requires:       python3dist(pydantic)
Requires:       python3dist(pynvml)
Requires:       python3dist(torch)
Requires:       python3dist(tqdm)
%description -n python3-%{pypi_name}
DeepSpeed is a deep learning optimization library that makes distributed 
training and inference easy, efficient, and effective. 


%prep
%autosetup -n %{pypi_name}-%{pypi_version}
sed -i '/ninja/d' requirements/requirements.txt
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info

%build
export FORCE_CUDA=1
export MAX_JOBS=%{_smp_build_ncpus}
export CUDA_HOME=/usr/local/cuda-%{vcu_maj}.%{vcu_min}
export LD_LIBRARY_PATH=/usr/local/cuda-%{vcu_maj}.%{vcu_min}/lib64/
export TORCH_CUDA_ARCH_LIST="%{gpu_target_bin}"
%py3_build

%install
export FORCE_CUDA=1
export CUDA_HOME=/usr/local/cuda-%{vcu_maj}.%{vcu_min}
export LD_LIBRARY_PATH=/usr/local/cuda-%{vcu_maj}.%{vcu_min}/lib64/
export TORCH_CUDA_ARCH_LIST="%{gpu_target_bin}"
%py3_install

%files -n python3-%{pypi_name}
%doc README.md
%{_bindir}/deepspeed
%{_bindir}/deepspeed.pt
%{_bindir}/ds
%{_bindir}/ds_bench
%{_bindir}/ds_elastic
%{_bindir}/ds_report
%{_bindir}/ds_ssh
%{_bindir}/dsr
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-%{pypi_version}-py%{python3_version}.egg-info

%changelog
* Thu Jan 18 2024 Zhongling He <zhonglingh@linux.alibaba.com> - 0.12.6-1
- Initial package.
